#include <iostream>
#include <fstream>
#include "symboltable.h"

using namespace std;

void display_symbol(Symbol &symbol, void *prepend) {
	cout << (char*)prepend << symbol.get_name() << endl;
}

int main() {
	SymbolTable table(10);

	string name;
	int value;

	bool done = false;
	while(!done) {
		cout << "What would you like to do?\n"
		     << "\tI: Insert a value\n"
		     << "\tR: Retrieve a value\n"
		     << "\tD: Delete a value\n"
		     << "\tS: Resize table\n"
		     << "\tC: Clear the table\n"
		     << "\tV: View table contents\n"
		     << "\tL: Load from file\n"
		     << "\tQ: quit?\n";

		char choice;
		cin >> choice;
		switch(choice) {
		case 'q': case 'Q':
			done = true;
			break;
		case 'i': case 'I':
			cout << "Enter symbol name: ";
			cin >> name;
			table.insert(name);
			break;
		case 'r': case 'R':
			cout << "Enter symbol name: ";
			cin >> name;
			Symbol *symbol;
			symbol = table.retrieve(name);
			if(symbol != NULL) {
				cout << name << " exists in table\n";
			} else {
				cout << name << " does not exist\n";
			}
			break;
		case 'd': case 'D':
			cout << "Enter a symbol name: ";
			cin >> name;
			table.erase(name);
			break;
		case 's': case 'S':
			cout << "Enter a new table size: ";
			int size;
			cin >> size;
			table.resize(size);
			break;
		case 'c': case 'C':
			table.clear();
			cout << "Table cleared\n";
			break;
		case 'v': case 'V':
			cout << "Table Contents:\n";
			table.traverse(display_symbol, (void*)"  Name: ");
			break;
		case 'l': case 'L':
			cout << "Enter a filename: ";
			cin >> name;
			ifstream fin(name.c_str());
			if(!fin) {
				cout << "Cannot open " << name << endl;
				break;
			}
			list<Symbol> tempHold;
			while(fin) {
				fin >> name;
				tempHold.push_front(name);
			}

			table.clear();
			table.resize(tempHold.size() * 2);
	
			list<Symbol>::iterator i;
			for(i = tempHold.begin(); i != tempHold.end(); i++) {
				table.insert(*i);
			}

			break;
		}
		cout << "\n\n";
    }
    return 0;
}

